<script setup lang="ts">
    import { User } from '@/api/user/User'
    import { ServiceOffer } from '@/serviceOffer/entities/serviceOffer/ServiceOffer'

    const user = defineModel<User>('modelValue', { required: true })

    defineProps<{
        availableRoles: ServiceOffer['availableRoles']
    }>()

    defineEmits<{
        (e: 'updateUser', updatedUser: User): void
    }>()
</script>

<template>
    <v-list-item data-cy="ligne-liste-utilisateur">
        <div class="d-flex justify-space-between">
            <v-list-item-title data-cy="user-email">
                {{ user.email }}
            </v-list-item-title>
            <slot> </slot>
        </div>
        <v-autocomplete
            v-model="user.roles"
            :items="availableRoles"
            chips
            auto-select-first
            item-title="libelle"
            label="Rôles"
            multiple
            variant="outlined"
            class="mt-1"
            data-cy="user-roles"
            @update:model-value="$emit('updateUser', user)"
        >
            <template #item="{ props, item }">
                <v-list-item v-bind="props" :value="item.value">
                    <template #prepend="{ isActive }">
                        <v-list-item-action start>
                            <v-checkbox-btn
                                :model-value="isActive"
                            ></v-checkbox-btn>
                        </v-list-item-action>
                    </template>

                    <v-list-item-subtitle>
                        {{
                            $vuetify.display.mdAndUp
                                ? item.raw.description
                                : undefined
                        }}
                    </v-list-item-subtitle>
                    <template v-if="$vuetify.display.smAndDown" #append>
                        <v-tooltip :text="item.raw.description" open-on-click>
                            <template #activator="{ props: activatorProps }">
                                <v-icon
                                    v-bind="activatorProps"
                                    icon="mdi-information-outline"
                                    color="info"
                                />
                            </template>
                        </v-tooltip>
                    </template>
                </v-list-item>
            </template>
        </v-autocomplete>
    </v-list-item>
</template>
